import type { Action, AnyAction, ThunkDispatch } from '@reduxjs/toolkit';
import { type DeepReadonly, type Ref } from 'vue';
import { type SelectorArray, type SelectorResultArray } from './utils';
export declare const contextKey_original: unique symbol;
export declare const contextKey_adapted: unique symbol;
/** select a state from store in nearest `Provider` */
export declare function useSelector<Result, State = unknown>(sel: (state: State) => Result): import("vue").ComputedRef<Result>;
/** select using multiple selectors */
/** select using create selector */
export declare function useSelectors<Selectors extends SelectorArray, Result, State = unknown>(...items: [...Selectors, (...args: [State, ...SelectorResultArray<Selectors>]) => Result]): import("vue").ComputedRef<unknown>;
/** get the store from nearest `Provider` */
export declare function useStore<State = unknown, A extends Action<any> = AnyAction>(): Readonly<Ref<DeepReadonly<State>>> & {
    dispatch: ThunkDispatch<State, any, A>;
};
/** get the dispatch method from nearest `Provider` */
export declare function useDispatch<State = unknown, A extends Action<any> = AnyAction>(): ThunkDispatch<State, any, A>;
