import { type DeepReadonly, type Ref } from 'vue';
/** select a state from readable store  */
export declare function select<Result, State = unknown>(sel: (state: State) => Result): (store: Readonly<Ref<DeepReadonly<State>>>) => import("vue").ComputedRef<Result>;
/** select using create selector */
export declare function selects<Selectors extends SelectorArray, Result, State = unknown>(...items: [...Selectors, (...args: [State, ...SelectorResultArray<Selectors>]) => Result]): (store: Readonly<Ref<DeepReadonly<State>>>) => import("vue").ComputedRef<unknown>;
export type SelectorResultArray<Selectors extends SelectorArray> = ExtractReturnType<Selectors>;
export type SelectorArray = ReadonlyArray<Selector>;
type ExtractReturnType<T extends readonly UnknownFunction[]> = {
    [index in keyof T]: T[index] extends T[number] ? ReturnType<T[index]> : never;
};
type Selector<State = any, Result = unknown, Params extends never | readonly any[] = any[]> = [Params] extends [never] ? (state: State) => Result : (state: State, ...params: Params) => Result;
type UnknownFunction = (...args: any[]) => any;
export {};
